import g4p_controls.*;

  GControlPalette cp0;
  GAnimIcon ai;
  GButton btnA, btnB, btnC;
  GButton btn0, btn1, btn2, btn3, btn4, btn5, btn6, btn7, btn8, btn9;
  GSlider sdr0;

  public void settings() {
    size(640,480);
  }

  public void setup() {
    G4P.messagesEnabled(false);
    surface.setTitle("001 Developing the GControlPlaette control");
    cursor(CROSS);
    textSize(16);
    ai = new GAnimIcon(this, "watch50.png", 7, 4, 100);
    ai.animate("ALL");
    cp0 = new GControlPalette(this, ai, GAlign.EAST, width/2 - 30, height/2);
    cp0.setOpaque(true);
    // Replace the default values for the border and padding
    // can always delete the next 2 statemnets to keep default values
    cp0.setBorder(1.5, 3.2);
    cp0.setPadding(4);
    //    cp0.setRotation(-0.6f);
    test_001(0);
    createGUI();
  }

  public void test_002(int n) {
    btn0 = new GButton(this, 0,0, 24, 18, "0");
    btn1 = new GButton(this, 0,0, 24, 18, "1");
    btn2 = new GButton(this, 0,0, 24, 18, "2");
    btn3 = new GButton(this, 0,0, 24, 18, "3");
    btn4 = new GButton(this, 0,0, 24, 18, "4");
    btn5 = new GButton(this, 0,0, 24, 18, "5");
    btn6 = new GButton(this, 0,0, 24, 18, "6");
    btn7 = new GButton(this, 0,0, 24, 18, "7");
    btn8 = new GButton(this, 0,0, 24, 18, "8");
    btn9 = new GButton(this, 0,0, 24, 18, "9");
    switch(n) {
    case 0:
    default:
      System.out.println("Test 2-0");
      cp0.addControls(btn0, btn1, btn2, btn3, btn4, btn5, btn6, btn7, btn8, btn9);
      break;
    case 1: 
      System.out.println("Test 2-1");
      // expected order 5012346789
      cp0.addControls(btn0, btn1, btn2, btn3, btn4, btn6, btn7, btn8, btn9);
      cp0.addControl(0, btn5);
      break;
    case 2: 
      System.out.println("Test 2-2");
      // expected order 0123469578
      cp0.addControls(btn0, btn1, btn2, btn3, btn4, btn6, btn9);
      cp0.addControls(btn5, btn7, btn8);
      break;
    case 3: 
      System.out.println("Test 2-3");
      // expected order 0578123469
      cp0.addControls(btn0, btn1, btn2, btn3, btn4, btn6, btn9);
      cp0.addControls(1, btn5, btn7, btn8);
      break;
    case 4: 
      System.out.println("Test 2-4");
      // remove first, last and middle controls 
      // expected order 1234578
      cp0.addControls(btn0, btn1, btn2, btn3, btn4, btn5, btn6, btn7, btn8, btn9);
      cp0.remove(btn0);
      cp0.remove(btn9);
      cp0.remove(btn6);
      break;
    case 5: 
      System.out.println("Test 2-5");
      // remove first, last (attempt) using index
      // expected order 123456789
      cp0.addControls(btn0, btn1, btn2, btn3, btn4, btn5, btn6, btn7, btn8, btn9);
      // To remove both 
      cp0.remove(0); // Valid idx 0-9
      cp0.remove(9); // Valid idx 0-8 so fails 
      break;
    case 6: 
      System.out.println("Test 2-6");
      // remove and dispose of btn2
      // expected order 013456789
      cp0.addControls(btn0, btn1, btn2, btn3, btn4, btn5, btn6, btn7, btn8, btn9);
      // To remove both 
      if(cp0.remove(btn2)) {
        btn2.dispose();
        btn2 = null; // Remove reference to enable garbage collection
      } // expected order 013456789
      break;
    case 7: 
      System.out.println("Test 2-7");
      // remove and dispose of button at position 6
      // expected order 012345789
      cp0.addControls(btn0, btn1, btn2, btn3, btn4, btn5, btn6, btn7, btn8, btn9);
      // To remove both 
      GAbstractControl c = cp0.remove(6);
      if(c != null) {
        c.dispose();
        // Will have memory leak the identifier used to create the button
        // still references it.
      } 
      break;
    }
  }
  
  public void test_001(int n) {
    // Make some buttons
    btnA = new GButton(this, 0, 0, 60, 20, "A");
    btnA.tag = "A";
    btnB = new GButton(this, 0, 0, 30, 30, "B");
    btnB.tag = "B";
    btnC = new GButton(this, 0, 0, 60, 25, "C");
    btnC.tag = "C";
    // Make a slider
    sdr0 = new GSlider(this, 0, 0, 100, 50, 10);
    sdr0.setLimits(50, 0, 100);
    sdr0.setNbrTicks(11);
    sdr0.setShowDecor(false, true, true, true);
    switch(n) {
    case 0:
    default:
      System.out.println("Test 1-0");
      cp0.addControl(btnA);
      cp0.addControl(sdr0);
      cp0.addControl(btnB);
      cp0.addControl(btnC);
      break;
    case 1:
      System.out.println("Test 1-1");
      cp0.addControl(btnA);
      cp0.addControl(btnB);
      cp0.addControl(sdr0);
      cp0.addControl(btnC);
      cp0.addControl(btnB); // duplicate should be ignored
      break;
    case 2:
      System.out.println("Test 1-2");
      cp0.addControls(btn0, btn1, sdr0, btn2, btn1);
      break;
    }
  }

  public void createGUI() {
    GToggleGroup tg = new GToggleGroup();
    GOption n, s, e, w;
    n = new GOption(this, 16, 0, 50, 16, "North");
    n.tag = "N";
    s = new GOption(this, 16, 20, 50, 16, "South");
    s.tag = "S";
    e = new GOption(this, 16, 40, 50, 16, "East");
    e.tag = "E";
    w = new GOption(this, 16, 60, 50, 16, "West");
    w.tag = "W";
    tg.addControls(n,s,e,w);
    e.setSelected(true);
    GCheckbox cbx = new GCheckbox(this, 16, 80, 80, 16, "Opaque");
    cbx.tag = "OPAQUE";
    cbx.setSelected(true);
  }

  public void draw() {
    background(240, 240,200);
    stroke(0);
    fill( cp0.fitsScreen(GAlign.NORTH) ? 0xFF00FF00 : 0xFFFF0000);
    ellipse(6, 8, 8, 8);
    fill( cp0.fitsScreen(GAlign.SOUTH) ? 0xFF00FF00 : 0xFFFF0000);
    ellipse(6, 28, 8, 8);
    fill( cp0.fitsScreen(GAlign.EAST) ? 0xFF00FF00 : 0xFFFF0000);
    ellipse(6, 48, 8, 8);
    fill( cp0.fitsScreen(GAlign.WEST) ? 0xFF00FF00 : 0xFFFF0000);
    ellipse(6, 68, 8, 8);
  }

  public void handleToggleControlEvents(GToggleControl option, GEvent event) { 
    switch(option.tag) {
    case "N":
      cp0.setPrefAlign(GAlign.NORTH);
      break;
    case "S":
      cp0.setPrefAlign(GAlign.SOUTH);
      break;
    case "E":
      cp0.setPrefAlign(GAlign.EAST);
      break;
    case "W":
      cp0.setPrefAlign(GAlign.WEST);
      break;
    case "OPAQUE":
      cp0.setOpaque(option.isSelected());
      break;
    }
  }
